{
  Author : Veeranna Ronad
         (Consultant)
  E-Mail : vyronad@usa.com, vyronad2@bol.net.in

  Library returns size of free disk space for large HDD's. 
}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Msdbnav, Db, DBTables, DBCtrls, Mask, Menus;

type
  TDiskSize = (dsB,dsKB,dsMB,dsGB);
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    ListBox1: TListBox;
    GroupBox2: TGroupBox;
    ListBox2: TListBox;
    GroupBox3: TGroupBox;
    Memo1: TMemo;
    Panel1: TPanel;
    BtnDemo: TButton;
    BtnFreeSpace: TButton;
    BtnClearResults: TButton;
    procedure BtnCloseClick(Sender: TObject);
    procedure BtnFreeSpaceClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BtnDemoClick(Sender: TObject);
    procedure BtnClearResultsClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  function GetFreeDiskSpace(sDrive : PChar; DiskSize : TDiskSize) : PChar;  safecall; external 'DskFree.dll';

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.BtnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.BtnFreeSpaceClick(Sender: TObject);
var
  sString : String;
  DiskSize : TDiskSize;
begin
  case ListBox2.ItemIndex of
    0 : DiskSize := dsB;
    1 : DiskSize := dsKB;
    2 : DiskSize := dsMB;
    3 : DiskSize := dsGB;
  end;
  sString := GetFreeDiskSpace(PChar(ListBox1.Items.Strings[ListBox1.ItemIndex]),DiskSize);
  if (sString <> '-1') then
    Memo1.Lines.Add(ListBox1.Items.Strings[ListBox1.ItemIndex] + ' - ' + sString)
  else
    Memo1.Lines.Add(ListBox1.Items.Strings[ListBox1.ItemIndex] + ' - ' + 'Unknown drive letter');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ListBox1.ItemIndex := 0;
  ListBox2.ItemIndex := 0;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = 27) then
    Close;
end;

procedure TForm1.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TForm1.BtnDemoClick(Sender: TObject);
var
  sString : String;
  DiskSize : TDiskSize;
  I, J : Integer;
begin
  I := 0; J := 0;
  for I := 0 to ListBox1.Items.Count-1 do begin
    ListBox1.ItemIndex := I;
    for J := 0 to ListBox2.Items.Count-1 do begin
      if not ListBox2.Selected[J] then
        ListBox2.ItemIndex := J;
      BtnFreeSpaceClick(nil);
    end;
  end;
end;

procedure TForm1.BtnClearResultsClick(Sender: TObject);
begin
  Memo1.Lines.Clear;
end;

end.
